	SECTION _TEXT CLASS=CODE USE32
	SECTION _DATA CLASS=DATA USE32
	SECTION _BSS  CLASS=BSS USE32
	SECTION cstartup CLASS=INITDATA USE32
	SECTION crundown CLASS=EXITDATA USE32
	SECTION cppinit  CLASS=CPPDATA USE32
	GROUP DGROUP _DATA _BSS

SECTION _TEXT
[GLOBAL	_ParseDir]
;
; Line 15:	{
;
_ParseDir:
	PUSH	EBP
	MOV	EBP,ESP
	PUSH	EBX
	PUSH	ESI
	PUSH	EDI
	MOV	ESI,DWORD [EBP+08H]
	MOV	EBX,DWORD [EBP+010H]
;
; Line 17:	   *drive = -1;
;
	MOV	EAX,DWORD [EBP+0CH]
	MOV	DWORD [EAX+00H],0FFFFFFFFH
;
; Line 18:	   *dir = 0;
;
	MOV	DWORD [EBX+00H],00H
;
; Line 19:	   *file = 0;
;
	MOV	EAX,DWORD [EBP+014H]
	MOV	DWORD [EAX+00H],00H
	JMP	L_1
L_3:
	INC	ESI
L_1:
;
; Line 21:	   while (*spec == ' ') spec++;
;
	MOVSX	EAX,BYTE [ESI+00H]
	CMP	EAX,BYTE 020H
	JE	SHORT	L_3
L_2:
;
; Line 23:	   spec2 = spec;
;
	MOV	EDI,ESI
	JMP	L_4
L_6:
;
; Line 25:	     *(spec2++) = toupper(*spec2);
;
	MOVSX	EAX,BYTE [EDI+00H]
	PUSH	EAX
	CALL	_toupper
	POP	ECX
	MOV	ECX,EDI
	INC	EDI
	MOV	BYTE [ECX+00H],AL
L_4:
;
; Line 24:	   while (*spec2)
;
	CMP	BYTE [EDI+00H],BYTE 00H
	JNE	NEAR	L_6
L_5:
;
; Line 27:	   if (*spec) {
;
	CMP	BYTE [ESI+00H],BYTE 00H
	JE	NEAR	L_7
;
; Line 28:	     if (*(spec+1) == ':') {
;
	MOVSX	EAX,BYTE [ESI+01H]
	CMP	EAX,BYTE 03AH
	JNE	SHORT	L_9
;
; Line 29:	       *drive = *spec - 'A' ;
;
	MOVSX	EAX,BYTE [ESI+00H]
	SUB	EAX,BYTE 041H
	MOV	ECX,DWORD [EBP+0CH]
	MOV	DWORD [ECX+00H],EAX
;
; Line 30:	       *dir = spec + 2 ;
;
	LEA	EAX,[ESI+02H]
	MOV	DWORD [EBX+00H],EAX
;
; Line 31:	     }
;
	JMP	L_10
L_9:
;
; Line 33:	       *dir = spec;
;
	MOV	DWORD [EBX+00H],ESI
L_10:
;
; Line 34:	   }
;
L_7:
;
; Line 36:	   if ((spec2 = strrchr(*dir,'\\')) != 0) {
;
	PUSH	BYTE 05CH
	PUSH	DWORD [EBX+00H]
	CALL	_strrchr
	ADD	ESP,BYTE 08H
	MOV	EDI,EAX
	TEST	EAX,EAX
	JE	SHORT	L_11
;
; Line 37:	     *spec2 = 0;
;
	MOV	BYTE [EDI+00H],00H
;
; Line 38:	     *file = spec2+1;
;
	LEA	EAX,[EDI+01H]
	MOV	ECX,DWORD [EBP+014H]
	MOV	DWORD [ECX+00H],EAX
;
; Line 39:	   }
;
	JMP	L_12
L_11:
;
; Line 41:	     *dir = 0;
;
	MOV	DWORD [EBX+00H],00H
;
; Line 42:	     *file = spec;
;
	MOV	EAX,DWORD [EBP+014H]
	MOV	DWORD [EAX+00H],ESI
;
; Line 43:	   }
;
L_12:
;
; Line 44:	}
;
	POP	EDI
	POP	ESI
	POP	EBX
	POP	EBP
	RET
[GLOBAL	_FirstFile]
;
; Line 46:	{
;
_FirstFile:
	PUSH	EBP
	MOV	EBP,ESP
;
; Line 47:	  if (_dos_findfirst(spec, 0x00         , &fileBlock ))
;
	PUSH	DWORD _fileBlock
	PUSH	BYTE 00H
	PUSH	DWORD [EBP+08H]
	CALL	__dos_findfirst
	ADD	ESP,BYTE 0CH
	TEST	EAX,EAX
	JE	SHORT	L_13
;
; Line 48:	    return(0);
;
	MOV	EAX,00H
	JMP	L_15
L_13:
;
; Line 49:	  return(fileBlock.name) ;
;
	LEA	EAX,[_fileBlock]
	ADD	EAX,BYTE 01EH
L_15:
	POP	EBP
	RET
[GLOBAL	_NextFile]
;
; Line 52:	{
;
_NextFile:
;
; Line 53:	  if (_dos_findnext( &fileBlock))
;
	PUSH	DWORD _fileBlock
	CALL	__dos_findnext
	POP	ECX
	TEST	EAX,EAX
	JE	SHORT	L_16
;
; Line 54:	    return(0);
;
	MOV	EAX,00H
	JMP	L_18
L_16:
;
; Line 55:	  return(fileBlock.name);
;
	LEA	EAX,[_fileBlock]
	ADD	EAX,BYTE 01EH
L_18:
	RET
[GLOBAL	_rfsort]
;
; Line 58:	{
;
_rfsort:
	PUSH	EBP
	MOV	EBP,ESP
;
; Line 59:		return(strcmp(*(char **)elem1, *(char **)elem2));
;
	MOV	EAX,DWORD [EBP+0CH]
	PUSH	DWORD [EAX+00H]
	MOV	EAX,DWORD [EBP+08H]
	PUSH	DWORD [EAX+00H]
	CALL	_strcmp
	ADD	ESP,BYTE 08H
L_19:
	POP	EBP
	RET
[GLOBAL	_litlate]
;
; Line 62:	{
;
_litlate:
	PUSH	EBP
	MOV	EBP,ESP
	PUSH	EBX
	PUSH	ESI
	PUSH	EDI
	MOV	EBX,DWORD [EBP+08H]
	MOV	EDI,DWORD [EBP+0CH]
;
; Line 64:		if (!t)
;
	TEST	EBX,EBX
	JNE	SHORT	L_22
;
; Line 65:			return 0;
;
	MOV	EAX,00H
	JMP	L_24
L_22:
;
; Line 66:		q = malloc(strlen(t)+4+strlen(dir));
;
	PUSH	EBX
	CALL	_strlen
	POP	ECX
	PUSH	EAX
	PUSH	DWORD [EBP+010H]
	CALL	_strlen
	POP	ECX
	MOV	ECX,EAX
	POP	EAX
	ADD	EAX,ECX
	ADD	EAX,BYTE 04H
	PUSH	EAX
	CALL	_malloc
	POP	ECX
	MOV	ESI,EAX
;
; Line 67:		if (!q)
;
	TEST	ESI,ESI
	JNE	SHORT	L_25
;
; Line 68:			fatal("out of memory");
;
	PUSH	DWORD L_20
	CALL	_fatal
	POP	ECX
L_25:
;
; Line 69:		if (drive != -1) {
;
	CMP	EDI,BYTE 0FFFFFFFFH
	JE	SHORT	L_27
;
; Line 70:			q[0] = drive + 'A';
;
	LEA	EAX,[EDI+041H]
	MOV	BYTE [ESI+00H],AL
;
; Line 71:			q[1] = ':';
;
	MOV	BYTE [ESI+01H],03AH
;
; Line 72:			q[2] = 0;
;
	MOV	BYTE [ESI+02H],00H
;
; Line 73:		}
;
L_27:
;
; Line 74:		strcat(q,dir);
;
	PUSH	DWORD [EBP+010H]
	PUSH	ESI
	CALL	_strcat
	ADD	ESP,BYTE 08H
;
; Line 75:		strcat(q,"\\");
;
	PUSH	DWORD L_21
	PUSH	ESI
	CALL	_strcat
	ADD	ESP,BYTE 08H
;
; Line 76:		strcat(q,t);
;
	PUSH	EBX
	PUSH	ESI
	CALL	_strcat
	ADD	ESP,BYTE 08H
;
; Line 77:		return q;
;
	MOV	EAX,ESI
L_24:
	POP	EDI
	POP	ESI
	POP	EBX
	POP	EBP
	RET
[GLOBAL	_ClearFiles]
;
; Line 80:	{
;
_ClearFiles:
	PUSH	EBX
	MOV	EBX,00H
	JMP	L_31
L_29:
;
; Line 83:			free(filelist[i]);
;
	MOV	EAX,DWORD [_filelist]
	PUSH	DWORD [EAX+EBX*4+00H]
	CALL	_free
	POP	ECX
;
; Line 82:		for (i= 0; i < filecount; i++)	
;
L_30:
	INC	EBX
L_31:
	CMP	EBX,DWORD [_filecount]
	JL	SHORT	L_29
L_32:
;
; Line 84:		free(filelist);
;
	PUSH	DWORD [_filelist]
	CALL	_free
	POP	ECX
;
; Line 85:		filelist = 0;
;
	MOV	DWORD [_filelist],00H
;
; Line 86:	}
;
	POP	EBX
	RET
[GLOBAL	_GrabFile]
;
; Line 88:	{
;
_GrabFile:
;
; Line 89:		if (filenum < filecount) 
;
	MOV	EAX,DWORD [_filenum]
	CMP	EAX,DWORD [_filecount]
	JGE	SHORT	L_33
;
; Line 90:			return filelist[filenum++];
;
	MOV	EAX,DWORD [_filelist]
	MOV	ECX,DWORD [_filenum]
	INC	DWORD [_filenum]
	MOV	EAX,DWORD [EAX+ECX*4+00H]
	JMP	L_35
L_33:
;
; Line 91:		return 0;
;
	MOV	EAX,00H
L_35:
	RET
[GLOBAL	_ReadFiles]
;
; Line 94:	{
;
_ReadFiles:
	PUSH	EBP
	MOV	EBP,ESP
	SUB	ESP,010CH
	PUSH	EBX
	MOV	EBX,DWORD [EBP+08H]
;
; Line 98:		strcpy(lspec,spec);
;
	PUSH	EBX
	LEA	EAX,[EBP+0FFFFFEFCH]
	PUSH	EAX
	CALL	_strcpy
	ADD	ESP,BYTE 08H
;
; Line 99:		ParseDir(lspec,&drive,&dir,&file);
;
	LEA	EAX,[EBP+0FFFFFEF4H]
	PUSH	EAX
	LEA	EAX,[EBP+0FFFFFEF8H]
	PUSH	EAX
	LEA	EAX,[EBP+0FFFFFFFCH]
	PUSH	EAX
	LEA	EAX,[EBP+0FFFFFEFCH]
	PUSH	EAX
	CALL	_ParseDir
	ADD	ESP,BYTE 010H
;
; Line 100:		filelist = malloc(sizeof(char *)*500);
;
	PUSH	DWORD 07D0H
	CALL	_malloc
	POP	ECX
	MOV	DWORD [_filelist],EAX
;
; Line 101:		if (!filelist)
;
	CMP	DWORD [_filelist],BYTE 00H
	JNE	SHORT	L_38
;
; Line 102:			fatal("no memory");
;
	PUSH	DWORD L_36
	CALL	_fatal
	POP	ECX
L_38:
;
; Line 103:		if ((filelist[0] = litlate(FirstFile(spec),drive,dir)) == 0) {
;
	PUSH	DWORD [EBP+0FFFFFEF8H]
	PUSH	DWORD [EBP+0FFFFFFFCH]
	PUSH	EBX
	CALL	_FirstFile
	POP	ECX
	PUSH	EAX
	CALL	_litlate
	ADD	ESP,BYTE 0CH
	MOV	ECX,DWORD [_filelist]
	MOV	DWORD [ECX+00H],EAX
	TEST	EAX,EAX
	JNE	SHORT	L_40
;
; Line 104:			ClearFiles();
;
	CALL	_ClearFiles
;
; Line 105:			return 0;
;
	MOV	EAX,00H
	JMP	L_42
L_40:
	JMP	L_43
L_45:
;
; Line 108:			if (filecount >= 500-1)
;
	CMP	DWORD [_filecount],01F3H
	JL	SHORT	L_46
;
; Line 109:				fatal("Too many files... qualify file names to limit to %d at a time",500);
;
	PUSH	DWORD 01F4H
	PUSH	DWORD L_37
	CALL	_fatal
	ADD	ESP,BYTE 08H
L_46:
L_43:
;
; Line 107:		while((filelist[++filecount] = litlate(NextFile(),drive,dir)) != 0)
;
	PUSH	DWORD [EBP+0FFFFFEF8H]
	PUSH	DWORD [EBP+0FFFFFFFCH]
	CALL	_NextFile
	PUSH	EAX
	CALL	_litlate
	ADD	ESP,BYTE 0CH
	MOV	ECX,DWORD [_filelist]
	INC	DWORD [_filecount]
	MOV	EDX,DWORD [_filecount]
	MOV	DWORD [ECX+EDX*4+00H],EAX
	TEST	EAX,EAX
	JNE	NEAR	L_45
L_44:
;
; Line 110:		qsort(filelist,filecount,sizeof(char *),rfsort);
;
	PUSH	DWORD _rfsort
	PUSH	BYTE 04H
	PUSH	DWORD [_filecount]
	PUSH	DWORD [_filelist]
	CALL	_qsort
	ADD	ESP,BYTE 010H
;
; Line 111:		return 1;
;
	MOV	EAX,01H
L_42:
	POP	EBX
	MOV	ESP,EBP
	POP	EBP
	RET
[GLOBAL	_NewName]
;
; Line 114:	{
;
_NewName:
	PUSH	EBP
	MOV	EBP,ESP
	PUSH	ESI
;
; Line 117:	   strcpy(namebuf, spec);
;
	PUSH	DWORD [EBP+08H]
	PUSH	DWORD L_48
	CALL	_strcpy
	ADD	ESP,BYTE 08H
;
; Line 118:	   if (!(pos = strrchr(namebuf,'.')))
;
	PUSH	BYTE 02EH
	PUSH	DWORD L_48
	CALL	_strrchr
	ADD	ESP,BYTE 08H
	MOV	ESI,EAX
	TEST	EAX,EAX
	JNE	SHORT	L_50
;
; Line 119:	     strcat(namebuf,".~");
;
	PUSH	DWORD L_49
	PUSH	DWORD L_48
	CALL	_strcat
	ADD	ESP,BYTE 08H
	JMP	L_51
L_50:
;
; Line 121:	     *(pos+4) = 0;
;
	MOV	BYTE [ESI+04H],00H
;
; Line 122:	     *(pos+3) = *(pos+2);
;
	MOV	AL,BYTE [ESI+02H]
	MOV	BYTE [ESI+03H],AL
;
; Line 123:	     *(pos+2) = *(pos+1);
;
	MOV	AL,BYTE [ESI+01H]
	MOV	BYTE [ESI+02H],AL
;
; Line 124:	     *(pos+1) = '~' ;
;
	MOV	BYTE [ESI+01H],07EH
;
; Line 125:	   }
;
L_51:
;
; Line 126:	   return(namebuf);
;
	LEA	EAX,[L_48]
L_52:
	POP	ESI
	POP	EBP
	RET
[GLOBAL	_repath]
;
; Line 129:	{
;
_repath:
	PUSH	EBP
	MOV	EBP,ESP
	SUB	ESP,BYTE 08H
	PUSH	EBX
	PUSH	ESI
	PUSH	EDI
	MOV	ESI,DWORD [EBP+0CH]
	MOV	EBX,DWORD [EBP+08H]
;
; Line 131:		int needslash = 1;
;
	MOV	DWORD [EBP+0FFFFFFFCH],01H
;
; Line 133:		if (name[0] == '\\' || name[1] == ':') {
;
	MOVSX	EAX,BYTE [ESI+00H]
	CMP	EAX,BYTE 05CH
	JE	SHORT	L_55
	MOVSX	EAX,BYTE [ESI+01H]
	CMP	EAX,BYTE 03AH
	JNE	SHORT	L_53
L_55:
;
; Line 134:			strcpy(dest,name);
;
	PUSH	ESI
	PUSH	EBX
	CALL	_strcpy
	ADD	ESP,BYTE 08H
;
; Line 135:			return;
;
	JMP	L_56
L_53:
;
; Line 137:		strcpy(dest,pwd);
;
	PUSH	DWORD [EBP+010H]
	PUSH	EBX
	CALL	_strcpy
	ADD	ESP,BYTE 08H
	JMP	L_57
L_59:
;
; Line 140:			if (*name =='.' && *(name+1) == '.') {
;
	MOVSX	EAX,BYTE [ESI+00H]
	CMP	EAX,BYTE 02EH
	JNE	NEAR	L_60
	MOVSX	EAX,BYTE [ESI+01H]
	CMP	EAX,BYTE 02EH
	JNE	NEAR	L_60
;
; Line 141:				if (needslash) {
;
	CMP	DWORD [EBP+0FFFFFFFCH],BYTE 00H
	JE	NEAR	L_62
;
; Line 142:					dest[strlen(dest)-1] = 0;
;
	PUSH	EBX
	CALL	_strlen
	POP	ECX
	MOV	BYTE [EBX+EAX+0FFFFFFFFH+00H],00H
;
; Line 143:					p = strrchr(dest,'\\');
;
	PUSH	BYTE 05CH
	PUSH	EBX
	CALL	_strrchr
	ADD	ESP,BYTE 08H
	MOV	DWORD [EBP+0FFFFFFF8H],EAX
;
; Line 144:					*p=0;
;
	MOV	EAX,DWORD [EBP+0FFFFFFF8H]
	MOV	BYTE [EAX+00H],00H
;
; Line 145:				}
;
L_62:
;
; Line 146:				name +=2;
;
	ADD	ESI,BYTE 02H
;
; Line 147:				needslash = 1;
;
	MOV	DWORD [EBP+0FFFFFFFCH],01H
;
; Line 148:			}
;
	JMP	L_61
L_60:
;
; Line 150:				char *dst = dest + strlen(dest);
;
	PUSH	EBX
	CALL	_strlen
	POP	ECX
	ADD	EAX,EBX
	MOV	EDI,EAX
;
; Line 151:				if (needslash && *name != '\\')
;
	CMP	DWORD [EBP+0FFFFFFFCH],BYTE 00H
	JE	SHORT	L_64
	MOVSX	EAX,BYTE [ESI+00H]
	CMP	EAX,BYTE 05CH
	JE	SHORT	L_64
;
; Line 152:					*dst++ = '\\';
;
	MOV	EAX,EDI
	INC	EDI
	MOV	BYTE [EAX+00H],05CH
L_64:
;
; Line 153:				needslash = 0;
;
	MOV	DWORD [EBP+0FFFFFFFCH],00H
;
; Line 154:				*dst++ = *name++;
;
	MOV	EAX,ESI
	INC	ESI
	MOV	ECX,EDI
	INC	EDI
	MOV	AL,BYTE [EAX+00H]
	MOV	BYTE [ECX+00H],AL
;
; Line 155:				*dst++ = 0;
;
	MOV	EAX,EDI
	INC	EDI
	MOV	BYTE [EAX+00H],00H
;
; Line 156:			}
;
L_61:
;
; Line 157:		}
;
L_57:
;
; Line 139:		while (*name) {
;
	CMP	BYTE [ESI+00H],BYTE 00H
	JNE	NEAR	L_59
L_58:
;
; Line 158:	}
;
L_56:
	POP	EDI
	POP	ESI
	POP	EBX
	MOV	ESP,EBP
	POP	EBP
	RET
[GLOBAL	_FileRecurse]
;
; Line 161:	{
;
_FileRecurse:
	PUSH	EBP
	MOV	EBP,ESP
	SUB	ESP,0210H
	PUSH	EBX
	PUSH	ESI
	PUSH	EDI
;
; Line 164:		filenum = 0;
;
	MOV	DWORD [_filenum],00H
;
; Line 165:		filecount = 0;
;
	MOV	DWORD [_filecount],00H
;
; Line 166:		remove ("ztbpjklx.xuz");
;
	PUSH	DWORD L_66
	CALL	_remove
	POP	ECX
	MOV	ESI,00H
	JMP	L_74
L_72:
;
; Line 170:			int drive = 0;
;
	MOV	DWORD [EBP+0FFFFFFFCH],00H
;
; Line 171:			if (FileNames[i][1] == ':')
;
	MOV	EAX,DWORD [EBP+0CH]
	MOV	EAX,DWORD [EAX+ESI*4+00H]
	MOVSX	EAX,BYTE [EAX+01H]
	CMP	EAX,BYTE 03AH
	JNE	SHORT	L_76
;
; Line 172:				drive = FileNames[i][0] - 'A' + 1;
;
	MOV	EAX,DWORD [EBP+0CH]
	MOV	EAX,DWORD [EAX+ESI*4+00H]
	MOVSX	EAX,BYTE [EAX+00H]
	ADD	EAX,BYTE 0FFFFFFC0H
	MOV	DWORD [EBP+0FFFFFFFCH],EAX
L_76:
;
; Line 173:			if (drive > 26)
;
	CMP	DWORD [EBP+0FFFFFFFCH],BYTE 01AH
	JLE	SHORT	L_78
;
; Line 174:				drive -= 32;
;
	SUB	DWORD [EBP+0FFFFFFFCH],BYTE 020H
L_78:
;
; Line 175:			if (!drive) {
;
	CMP	DWORD [EBP+0FFFFFFFCH],BYTE 00H
	JNE	SHORT	L_80
;
; Line 176:				_dos_getdrive(&drive);
;
	LEA	EAX,[EBP+0FFFFFFFCH]
	PUSH	EAX
	CALL	__dos_getdrive
	POP	ECX
;
; Line 177:			}
;
L_80:
;
; Line 178:			_dos_getpwd(pwd+3,drive);
;
	PUSH	DWORD [EBP+0FFFFFFFCH]
	LEA	EAX,[EBP+0FFFFFEFCH]
	ADD	EAX,BYTE 03H
	PUSH	EAX
	CALL	__dos_getpwd
	ADD	ESP,BYTE 08H
;
; Line 179:			pwd[0] = drive - 1 + 'A';
;
	MOV	EAX,DWORD [EBP+0FFFFFFFCH]
	ADD	EAX,BYTE 040H
	MOV	BYTE [EBP+0FFFFFEFCH],AL
;
; Line 180:			pwd[1] = ':';
;
	MOV	BYTE [EBP+0FFFFFEFDH],03AH
;
; Line 181:			pwd[2] = '\\';
;
	MOV	BYTE [EBP+0FFFFFEFEH],05CH
;
; Line 182:			repath(buffer,FileNames[i],pwd);
;
	LEA	EAX,[EBP+0FFFFFEFCH]
	PUSH	EAX
	MOV	EAX,DWORD [EBP+0CH]
	PUSH	DWORD [EAX+ESI*4+00H]
	LEA	EAX,[EBP+0FFFFFDFCH]
	PUSH	EAX
	CALL	_repath
	ADD	ESP,BYTE 0CH
;
; Line 183:			if (ext)
;
	CMP	DWORD [EBP+018H],BYTE 00H
	JE	SHORT	L_82
;
; Line 184:				AddExt(buffer,ext);
;
	PUSH	DWORD [EBP+018H]
	LEA	EAX,[EBP+0FFFFFDFCH]
	PUSH	EAX
	CALL	_AddExt
	ADD	ESP,BYTE 08H
L_82:
;
; Line 185:	    if (ReadFiles(buffer) == 0) {
;
	LEA	EAX,[EBP+0FFFFFDFCH]
	PUSH	EAX
	CALL	_ReadFiles
	POP	ECX
	TEST	EAX,EAX
	JNE	SHORT	L_84
;
; Line 186:	       fprintf((_pstreams[2]),"No Such Files %s.\n",buffer);
;
	LEA	EAX,[EBP+0FFFFFDFCH]
	PUSH	EAX
	PUSH	DWORD L_67
	PUSH	DWORD [08H+__pstreams]
	CALL	_fprintf
	ADD	ESP,BYTE 0CH
;
; Line 187:	       continue;
;
L_84:
;
; Line 189:		}
;
;
; Line 167:	  for (i=0; i< count; i++) {
;
L_73:
	INC	ESI
L_74:
	CMP	ESI,DWORD [EBP+08H]
	JL	NEAR	L_72
L_75:
	JMP	L_86
L_88:
;
; Line 191:	    if (backup) {
;
	CMP	DWORD [EBP+01CH],BYTE 00H
	JE	NEAR	L_89
;
; Line 192:				char *newName = NewName(fileName);
;
	PUSH	EBX
	CALL	_NewName
	POP	ECX
	MOV	DWORD [EBP+0FFFFFDF0H],EAX
;
; Line 194:				if (Text) {
;
	CMP	DWORD [EBP+010H],BYTE 00H
	JE	NEAR	L_91
;
; Line 195:					printf("%s %s to %s\n",Text, fileName, newName);
;
	PUSH	DWORD [EBP+0FFFFFDF0H]
	PUSH	EBX
	PUSH	DWORD [EBP+010H]
	PUSH	DWORD L_68
	CALL	_printf
	ADD	ESP,BYTE 010H
;
; Line 196:					outf = fopen(newName,"w");
;
	PUSH	DWORD L_69
	PUSH	DWORD [EBP+0FFFFFDF0H]
	CALL	_fopen
	ADD	ESP,BYTE 08H
	MOV	DWORD [EBP+0FFFFFDF8H],EAX
;
; Line 197:					inf = fopen(fileName,"r");
;
	PUSH	DWORD L_70
	PUSH	EBX
	CALL	_fopen
	ADD	ESP,BYTE 08H
	MOV	DWORD [EBP+0FFFFFDF4H],EAX
;
; Line 198:					(*routine)(inf, outf, fileName);
;
	PUSH	EBX
	PUSH	DWORD [EBP+0FFFFFDF8H]
	PUSH	DWORD [EBP+0FFFFFDF4H]
	CALL	DWORD [EBP+014H]
	ADD	ESP,BYTE 0CH
;
; Line 199:					fclose (outf);
;
	PUSH	DWORD [EBP+0FFFFFDF8H]
	CALL	_fclose
	POP	ECX
;
; Line 200:					fclose (inf);
;
	PUSH	DWORD [EBP+0FFFFFDF4H]
	CALL	_fclose
	POP	ECX
;
; Line 201:					rename (newName,"ztbpjklx.xuz");
;
	PUSH	DWORD L_66
	PUSH	DWORD [EBP+0FFFFFDF0H]
	CALL	_rename
	ADD	ESP,BYTE 08H
;
; Line 202:					rename (fileName, newName );
;
	PUSH	DWORD [EBP+0FFFFFDF0H]
	PUSH	EBX
	CALL	_rename
	ADD	ESP,BYTE 08H
;
; Line 203:					rename ("ztbpjklx.xuz", fileName);
;
	PUSH	EBX
	PUSH	DWORD L_66
	CALL	_rename
	ADD	ESP,BYTE 08H
;
; Line 204:	      }
;
L_91:
;
; Line 205:			}
;
	JMP	L_90
L_89:
;
; Line 208:				if (Text)
;
	CMP	DWORD [EBP+010H],BYTE 00H
	JE	SHORT	L_93
;
; Line 209:					printf("%s %s\n", Text, fileName);
;
	PUSH	EBX
	PUSH	DWORD [EBP+010H]
	PUSH	DWORD L_71
	CALL	_printf
	ADD	ESP,BYTE 0CH
L_93:
;
; Line 210:				inf = fopen(fileName,"r");
;
	PUSH	DWORD L_70
	PUSH	EBX
	CALL	_fopen
	ADD	ESP,BYTE 08H
	MOV	EDI,EAX
;
; Line 211:				(*routine)(inf, 0, fileName);
;
	PUSH	EBX
	PUSH	BYTE 00H
	PUSH	EDI
	CALL	DWORD [EBP+014H]
	ADD	ESP,BYTE 0CH
;
; Line 212:				fclose( inf );
;
	PUSH	EDI
	CALL	_fclose
	POP	ECX
;
; Line 213:	    }
;
L_90:
;
; Line 214:		}
;
L_86:
;
; Line 190:	  while ((fileName = GrabFile()) != 0) {
;
	CALL	_GrabFile
	MOV	EBX,EAX
	TEST	EAX,EAX
	JNE	NEAR	L_88
L_87:
;
; Line 215:		ClearFiles();
;
	CALL	_ClearFiles
;
; Line 216:	  return(0);
;
	MOV	EAX,00H
L_95:
	POP	EDI
	POP	ESI
	POP	EBX
	MOV	ESP,EBP
	POP	EBP
	RET

L_71:
	DB	025H,073H,020H,025H,073H,0AH,00H
L_70:
	DB	072H,00H
L_69:
	DB	077H,00H
L_68:
	DB	025H,073H,020H,025H,073H,020H,074H,06FH,020H,025H,073H,0AH
	DB	00H
L_67:
	DB	04EH,06FH,020H,053H,075H,063H,068H,020H,046H,069H,06CH,065H
	DB	073H,020H,025H,073H,02EH,0AH,00H
L_66:
	DB	07AH,074H,062H,070H,06AH,06BH,06CH,078H,02EH,078H,075H,07AH
	DB	00H
L_49:
	DB	02EH,07EH,00H
L_37:
	DB	054H,06FH,06FH,020H,06DH,061H,06EH,079H,020H,066H,069H,06CH
	DB	065H,073H,02EH,02EH,02EH,020H,071H,075H,061H,06CH,069H,066H
	DB	079H,020H,066H,069H,06CH,065H,020H,06EH,061H,06DH,065H,073H
	DB	020H,074H,06FH,020H,06CH,069H,06DH,069H,074H,020H,074H,06FH
	DB	020H,025H,064H,020H,061H,074H,020H,061H,020H,074H,069H,06DH
	DB	065H,00H
L_36:
	DB	06EH,06FH,020H,06DH,065H,06DH,06FH,072H,079H,00H
L_21:
	DB	05CH,00H
L_20:
	DB	06FH,075H,074H,020H,06FH,066H,020H,06DH,065H,06DH,06FH,072H
	DB	079H,00H
SECTION _DATA

_filelist	DD	00H

_filenum	DD	00H

_filecount	DD	00H
SECTION _BSS

_fileBlock	RESB	012BH
	RESB	01H

L_48	RESB	0FH

SECTION _TEXT
[EXTERN	_fatal]
[EXTERN	_fprintf]
[EXTERN	_remove]
[EXTERN	_free]
[EXTERN	_strcpy]
[EXTERN	_fopen]
[EXTERN	_rename]
[EXTERN	_AddExt]
[EXTERN	__dos_findnext]
[EXTERN	_strcat]
[EXTERN	_qsort]
[EXTERN	_malloc]
[EXTERN	_fclose]
[EXTERN	_strrchr]
[EXTERN	_printf]
[EXTERN	__dos_findfirst]
[EXTERN	__dos_getdrive]
[EXTERN	__dos_getpwd]
[EXTERN	_strlen]
[EXTERN	_strcmp]
[EXTERN	_toupper]

SECTION _DATA
[EXTERN	__pstreams]
