	SECTION _TEXT CLASS=CODE USE32
	SECTION _DATA CLASS=DATA USE32
	SECTION _BSS  CLASS=BSS USE32
	SECTION cstartup CLASS=INITDATA USE32
	SECTION crundown CLASS=EXITDATA USE32
	SECTION cppinit  CLASS=CPPDATA USE32
	GROUP DGROUP _DATA _BSS

SECTION _TEXT
;
; Line 29:	{
;
_boolargs:
	PUSH	EBP
	MOV	EBP,ESP
;
; Line 30:	  switch (select) {
;
	MOV	AL,BYTE [EBP+08H]
	CMP	AL,BYTE 076H
	JNE	SHORT	L_2
L_4:
;
; Line 32:					verbose = 1;
;
	MOV	DWORD [_verbose],01H
;
; Line 33:	        break;
;
L_2:
L_3:
;
; Line 35:	}
;
	POP	EBP
	RET
[GLOBAL	_itouch]
;
; Line 37:	{
;
_itouch:
	PUSH	EBP
	MOV	EBP,ESP
	SUB	ESP,BYTE 04H
	PUSH	EBX
	MOV	EBX,DWORD [EBP+010H]
;
; Line 39:		if (verbose) {
;
	CMP	DWORD [_verbose],BYTE 00H
	JE	SHORT	L_6
;
; Line 40:			printf("Touching %s\n",fname);
;
	PUSH	EBX
	PUSH	DWORD L_5
	CALL	_printf
	ADD	ESP,BYTE 08H
;
; Line 41:		}
;
L_6:
;
; Line 42:		_dos_open(fname,0, &handle);
;
	LEA	EAX,[EBP+0FFFFFFFCH]
	PUSH	EAX
	PUSH	BYTE 00H
	PUSH	EBX
	CALL	__dos_open
	ADD	ESP,BYTE 0CH
;
; Line 43:		_dos_setftime(handle,absdate,abstime);
;
	MOVZX	EAX,WORD [_abstime]
	PUSH	EAX
	MOVZX	EAX,WORD [_absdate]
	PUSH	EAX
	PUSH	DWORD [EBP+0FFFFFFFCH]
	CALL	__dos_setftime
	ADD	ESP,BYTE 0CH
;
; Line 44:		_dos_close(handle);
;
	PUSH	DWORD [EBP+0FFFFFFFCH]
	CALL	__dos_close
	POP	ECX
;
; Line 46:	}
;
	POP	EBX
	MOV	ESP,EBP
	POP	EBP
	RET
[GLOBAL	_main]
;
; Line 49:	{
;
_main:
	PUSH	EBP
	MOV	EBP,ESP
	SUB	ESP,BYTE 04H
	PUSH	ESI
	PUSH	EDI
	MOV	EDI,DWORD [EBP+0CH]
;
; Line 53:	  banner("itouch"" Version %d.%02d  Copyright (c) 1994-1998 LADsoft",(100)/100,(100)%100);
;
	PUSH	BYTE 00H
	PUSH	BYTE 01H
	PUSH	DWORD L_8
	CALL	_banner
	ADD	ESP,BYTE 0CH
;
; Line 55:	  if (!parse_args(&argc, argv, 0) || (argc == 1))
;
	PUSH	BYTE 00H
	PUSH	EDI
	LEA	EAX,[EBP+08H]
	PUSH	EAX
	CALL	_parse_args
	ADD	ESP,BYTE 0CH
	TEST	EAX,EAX
	JE	SHORT	L_11
	CMP	DWORD [EBP+08H],BYTE 01H
	JNE	SHORT	L_9
L_11:
;
; Line 56:	    usage(argv[0]);
;
	PUSH	DWORD [EDI+00H]
	CALL	_usage
	POP	ECX
L_9:
;
; Line 58:		time(&xtime);
;
	LEA	EAX,[EBP+0FFFFFFFCH]
	PUSH	EAX
	CALL	_time
	POP	ECX
;
; Line 59:		tms = localtime(&xtime);
;
	LEA	EAX,[EBP+0FFFFFFFCH]
	PUSH	EAX
	CALL	_localtime
	POP	ECX
	MOV	ESI,EAX
;
; Line 61:		abstime = (tms->tm_hour << 11) | (tms->tm_min << 5) | ((tms->tm_sec+1)/2);
;
	MOV	EAX,DWORD [ESI+08H]
	SAL	EAX,0BH
	MOV	ECX,DWORD [ESI+04H]
	SAL	ECX,05H
	OR	EAX,ECX
	MOV	ECX,DWORD [ESI+00H]
	INC	ECX
	SAR	ECX,01H
	OR	EAX,ECX
	MOV	WORD [_abstime],AX
;
; Line 62:		absdate = ((tms->tm_year-1980) << 9) | ((tms->tm_mon+1) << 5) | (tms->tm_mday);
;
	MOV	EAX,DWORD [ESI+014H]
	SUB	EAX,07BCH
	SAL	EAX,09H
	MOV	ECX,DWORD [ESI+010H]
	INC	ECX
	SAL	ECX,05H
	OR	EAX,ECX
	OR	EAX,DWORD [ESI+0CH]
	MOV	WORD [_absdate],AX
;
; Line 65:	  FileRecurse(argc-1, argv+1, 0, itouch, 0, 0);
;
	PUSH	BYTE 00H
	PUSH	BYTE 00H
	PUSH	DWORD _itouch
	PUSH	BYTE 00H
	LEA	EAX,[EDI+04H]
	PUSH	EAX
	MOV	EAX,DWORD [EBP+08H]
	DEC	EAX
	PUSH	EAX
	CALL	_FileRecurse
	ADD	ESP,BYTE 018H
;
; Line 67:	  return(0);
;
	MOV	EAX,00H
L_12:
	POP	EDI
	POP	ESI
	MOV	ESP,EBP
	POP	EBP
	RET

L_8:
	DB	069H,074H,06FH,075H,063H,068H,020H,056H,065H,072H,073H,069H
	DB	06FH,06EH,020H,025H,064H,02EH,025H,030H,032H,064H,020H,020H
	DB	043H,06FH,070H,079H,072H,069H,067H,068H,074H,020H,028H,063H
	DB	029H,020H,031H,039H,039H,034H,02DH,031H,039H,039H,038H,020H
	DB	04CH,041H,044H,073H,06FH,066H,074H,00H
L_5:
	DB	054H,06FH,075H,063H,068H,069H,06EH,067H,020H,025H,073H,0AH
	DB	00H
L_1:
	DB	05BH,02DH,076H,05DH,020H,02EH,02EH,02EH,00H
SECTION _DATA
[GLOBAL	_usage_text]

_usage_text	DD	L_1

_verbose	DD	00H
[GLOBAL	_ArgList]

_ArgList	DB	076H,04H
	RESB	02H
	DD	_boolargs
	DB	00H,00H
	RESB	02H
	DD	00H
SECTION _BSS

_absdate	RESB	02H

_abstime	RESB	02H

SECTION _TEXT
[EXTERN	__dos_open]
[EXTERN	_time]
[EXTERN	_usage]
[EXTERN	_parse_args]
[EXTERN	_banner]
[EXTERN	__dos_setftime]
[EXTERN	_localtime]
[EXTERN	_printf]
[EXTERN	_FileRecurse]
[EXTERN	__dos_close]
